import themidibus.*; //Import the library

MidiBus myBus; // The MidiBus

boolean ACTIVE = true;

void setup() 
{
  size(400, 400);
  background(0);

  MidiBus.list(); // List all available Midi devices on STDOUT. This will show each device's index and name.

  // Either you can
  //                   Parent In Out
  //                     |    |  |
  myBus = new MidiBus(this,  -1, 1); // Create a new MidiBus using the device index to select the Midi input and output devices respectively.
}

//Again: Chaos function ;-)
float r = 3.94;
float y_old = 0.56;
float y_new = 0.0;
int value=0;

public int nextValue()
{
  y_new = r*y_old*(1.0 - y_old);
  y_old = y_new;
  return (int)(100.0*y_new);    
}

void draw() 
{
  
  
  if(ACTIVE==false)
  {
      myBus.clearAll();
      background(0,255,0);
      return;
  }
  background(255,0,0);
  
  int channel = nextValue()%5;
  int pitch = 48 + nextValue()%49;
  int velocity = 50 + 10*(nextValue()%5);

  myBus.sendNoteOn(channel, pitch, velocity); // Send a Midi noteOn
  delay(100);
  myBus.sendNoteOff(channel, pitch, velocity); // Send a Midi nodeOff
  delay(100);
}

void delay(int time) 
{
  int current = millis();
  while(millis () < current+time)
  {
      Thread.yield();
  }    
}

void keyPressed() 
{
  if (key == ' ') 
  {
      ACTIVE = false;
  }
}